// Rx_01.ino
// ESP32 @ IED 1.8.16
// receiver for one sender

#include <esp_now.h>
#include <WiFi.h>

//Structure to receive data must match sender structure
typedef struct test_struct 
{ int x;  int y;} test_struct;
test_struct myData;

void OnDataRecv(const uint8_t * mac, const uint8_t *incomingData, int len) 
{ memcpy(&myData, incomingData, sizeof(myData));
  Serial.print("Bytes received: ");  Serial.println(len);
  Serial.print("x: ");  Serial.println(myData.x);
  Serial.print("y: ");  Serial.println(myData.y);
  Serial.println();
}
 
void setup() 
{ Serial.begin(115200);
  WiFi.mode(WIFI_STA);
  if (esp_now_init() != ESP_OK) { Serial.println("Error initializing ESP-NOW"); return; }
  esp_now_register_recv_cb(OnDataRecv);
}
 
void loop() {}
