// Rx_01_LED_control.ino
// ESP32 @ IED 1.8.16
// receiver for one sender for controlling LEDs

#include <esp_now.h>
#include <WiFi.h>

byte LEDpin=14;  // or 16,  ...

//Structure to receive data must match sender structure
typedef struct test_struct 
{ bool x;  bool y;} test_struct;
test_struct myData;

void OnDataRecv(const uint8_t * mac, const uint8_t *incomingData, int len) 
{ memcpy(&myData, incomingData, sizeof(myData));
  Serial.print("Bytes received: ");  Serial.println(len);
  Serial.print("x: ");  Serial.println(myData.x);
  Serial.print("y: ");  Serial.println(myData.y);
  Serial.println();
  Serial.print("Switch State: "); Serial.println(myData.x);
  digitalWrite(LEDpin,myData.x);
}
 
void setup() 
{ Serial.begin(115200); WiFi.mode(WIFI_STA);
  pinMode(LEDpin,OUTPUT);
  if (esp_now_init() != ESP_OK) { Serial.println("Error initializing ESP-NOW"); return; }
  esp_now_register_recv_cb(OnDataRecv);
}
 
void loop() {}
