// Tx_00_diff.ino
// ESP32 @ IED 1.8.16
// sender for multiple receivers different data

#include <esp_now.h>
#include <WiFi.h>

// REPLACE WITH YOUR ESP RECEIVER'S MAC ADDRESS
uint8_t broadcastAddress1[] = {0x80, 0x7D, 0x3A, 0xDC, 0x67, 0x1C};   
uint8_t broadcastAddress2[] = {0x80, 0x7D, 0x3A, 0xDC, 0x53, 0x28};   
uint8_t broadcastAddress3[] = {0x80, 0x7D, 0x3A, 0xDC, 0xFF, 0xFF};   

typedef struct test_struct { int x;  int y;} test_struct;

void OnDataSent(const uint8_t *mac_addr, esp_now_send_status_t status) 
{ char macStr[18]; Serial.print("Packet to: ");
  snprintf(macStr, sizeof(macStr), "%02x:%02x:%02x:%02x:%02x:%02x",
           mac_addr[0], mac_addr[1], mac_addr[2], mac_addr[3], mac_addr[4], mac_addr[5]);
  Serial.print(macStr);
  Serial.print(status==ESP_NOW_SEND_SUCCESS?" Data Sent ":" Send Fail ");
}
 
void setup() 
{ Serial.begin(115200);
  WiFi.mode(WIFI_STA);
  if (esp_now_init() != ESP_OK) {Serial.println("Error initializing ESP-NOW"); return;}
  esp_now_register_send_cb(OnDataSent);
  esp_now_peer_info_t peerInfo;
  peerInfo.channel = 0;    peerInfo.encrypt = false;
    
  memcpy(peerInfo.peer_addr, broadcastAddress1, 6);
  if (esp_now_add_peer(&peerInfo) != ESP_OK){ Serial.println("Failed to add peer"); return;}
  memcpy(peerInfo.peer_addr, broadcastAddress2, 6);
  if (esp_now_add_peer(&peerInfo) != ESP_OK){ Serial.println("Failed to add peer"); return;}
  memcpy(peerInfo.peer_addr, broadcastAddress3, 6);
  if (esp_now_add_peer(&peerInfo) != ESP_OK){ Serial.println("Failed to add peer"); return;}
}
 
void loop() 
{ test_struct test1;  test_struct test2;  test_struct test3;
  test1.x=123;  test1.y=456; test2.x=321;  test2.y=654; test3.x=0;  test3.y=0;
  esp_err_t result1=esp_now_send(broadcastAddress1, (uint8_t *) &test1, sizeof(test_struct));
  Serial.println(result1==ESP_OK?"Delivery Success":"Delivery Fail"); delay(300);
  esp_err_t result2=esp_now_send(broadcastAddress2,  (uint8_t *) &test2, sizeof(test_struct));
  Serial.println(result2==ESP_OK?"Delivery Success":"Delivery Fail"); delay(300);  
  esp_err_t result3=esp_now_send(broadcastAddress3, (uint8_t *) &test3, sizeof(test_struct)); 
  Serial.println(result3==ESP_OK?"Delivery Success":"Delivery Fail"); delay(300);  
}
