// Tx_00_diff_LED_control.ino
// ESP32 @ IED 1.8.16
// sender for multiple receivers - different data for controlling LEDs

#include <esp_now.h>
#include <WiFi.h>

// REPLACE WITH YOUR ESP RECEIVER'S MAC ADDRESS
uint8_t broadcastAddress1[] = {0x80, 0x7D, 0x3A, 0xDC, 0x67, 0x1C};  // Brd # 10:   80:7D:3A:DC:67:1C
uint8_t broadcastAddress2[] = {0xCC, 0x50, 0xE3, 0x9C, 0x0C, 0x74};  // NodeMCU #1: CC:50:E3:9C:0C:74
uint8_t broadcastAddress3[] = {0x30, 0xAE, 0xA4, 0xF5, 0x7A, 0xE8};  // Brd # N2:   30:AE:A4:F5:7A:E8

byte LED1pin=12, LED2pin=14;

typedef struct test_struct 
{ bool x;  bool y;} test_struct;

void OnDataSent(const uint8_t *mac_addr, esp_now_send_status_t status) 
{ char macStr[18]; Serial.print("Packet to: ");
  snprintf(macStr, sizeof(macStr), "%02x:%02x:%02x:%02x:%02x:%02x",
           mac_addr[0], mac_addr[1], mac_addr[2], mac_addr[3], mac_addr[4], mac_addr[5]);
  Serial.print(macStr); Serial.print(": ");
  Serial.println(status == ESP_NOW_SEND_SUCCESS ? "Data Sent " : "Send Fail ");
}
 
void setup() 
{ Serial.begin(115200);  WiFi.mode(WIFI_STA);
  if (esp_now_init() != ESP_OK) {Serial.println("Error initializing ESP-NOW"); return;}
  esp_now_register_send_cb(OnDataSent);
  esp_now_peer_info_t peerInfo;
  peerInfo.channel = 0; peerInfo.encrypt = false;
    
  memcpy(peerInfo.peer_addr, broadcastAddress1, 6);
  if (esp_now_add_peer(&peerInfo) != ESP_OK){ Serial.println("Failed to add peer"); return;}
  memcpy(peerInfo.peer_addr, broadcastAddress2, 6);
  if (esp_now_add_peer(&peerInfo) != ESP_OK){ Serial.println("Failed to add peer"); return;}
  memcpy(peerInfo.peer_addr, broadcastAddress3, 6);
  if (esp_now_add_peer(&peerInfo) != ESP_OK){ Serial.println("Failed to add peer"); return;}

  pinMode(LED1pin,INPUT_PULLUP); pinMode(LED2pin,INPUT_PULLUP);
}
 
void loop() 
{ test_struct LED1;  test_struct LED2;  test_struct LED3;
  if (digitalRead(LED1pin)==false)  LED1.x=true;  else LED1.x=false;
  if (digitalRead(LED2pin)==false)  LED2.x=true;  else LED2.x=false;
  
  Serial.println(LED1.x); Serial.println(LED2.x);
  
  esp_err_t result1 = esp_now_send( broadcastAddress1, (uint8_t *) &LED1, sizeof(test_struct));
  if (result1 == ESP_OK) { Serial.print("Sent with success ");} else {Serial.println("Error sending data ");} delay(100);
  esp_err_t result2 = esp_now_send( broadcastAddress2,  (uint8_t *) &LED2, sizeof(test_struct));
  if (result2 == ESP_OK) {Serial.print("Sent with success ");}  else {Serial.println("Error sending the data ");} delay(100);  
  esp_err_t result3 = esp_now_send(broadcastAddress3, (uint8_t *) &LED3, sizeof(test_struct));
  if (result3 == ESP_OK) { Serial.print("Sent with success "); } else {Serial.println("Error sending the data ");} delay(100);
}
