// Tx_00_ident.ino
// ESP32 @ IED 1.8.16
// sender for multiple receivers

#include <esp_now.h>
#include <WiFi.h>

// REPLACE WITH YOUR ESP RECEIVER'S MAC ADDRESS
uint8_t broadcastAddress1[] = {0x80, 0x7D, 0x3A, 0xDC, 0x67, 0x1C};  // Board 10: 80:7D:3A:DC:67:1C
uint8_t broadcastAddress2[] = {0x80, 0x7D, 0x3A, 0xDC, 0x53, 0x28};  // Board 13: 80:7D:3A:DC:53:28
uint8_t broadcastAddress3[] = {0x80, 0x7D, 0x3A, 0xDC, 0xFF, 0xFF};  // Board XX: 

typedef struct test_struct 
{ int x;  int y;
} test_struct;

test_struct test;
esp_now_peer_info_t peerInfo;

void OnDataSent(const uint8_t *mac_addr, esp_now_send_status_t status) 
{ char macStr[18];
  Serial.print("Packet to: ");
  snprintf(macStr, sizeof(macStr), "%02x:%02x:%02x:%02x:%02x:%02x",
           mac_addr[0], mac_addr[1], mac_addr[2], mac_addr[3], mac_addr[4], mac_addr[5]);
  Serial.print(macStr);
  Serial.print(" send status:\t");
  Serial.println(status == ESP_NOW_SEND_SUCCESS ? "Delivery Success" : "Delivery Fail");
}
 
void setup() 
{ Serial.begin(115200); WiFi.mode(WIFI_STA);
  if (esp_now_init() != ESP_OK) {    Serial.println("Error initializing ESP-NOW");    return;  }
  esp_now_register_send_cb(OnDataSent);
  peerInfo.channel = 0; peerInfo.encrypt = false;
  memcpy(peerInfo.peer_addr, broadcastAddress1, 6);
  if (esp_now_add_peer(&peerInfo) != ESP_OK){Serial.println("Failed to add peer"); return; }
  memcpy(peerInfo.peer_addr, broadcastAddress2, 6);
  if (esp_now_add_peer(&peerInfo) != ESP_OK){    Serial.println("Failed to add peer");    return;  }
  memcpy(peerInfo.peer_addr, broadcastAddress3, 6);
  if (esp_now_add_peer(&peerInfo) != ESP_OK){    Serial.println("Failed to add peer");    return;  }
}
 
void loop() 
{ test.x = 123;  test.y = 456;
  esp_err_t result = esp_now_send(0, (uint8_t *) &test, sizeof(test_struct));
  if (result == ESP_OK) Serial.println("Package Sent"); else Serial.println("Send Fail");  
  delay(2000);
}
