// Tx_01.ino
// ESP32 @ IDE 1.8.16

#include <esp_now.h>
#include <WiFi.h>

uint8_t broadcastAddress[] = {0x80,0x7D,0x3A,0xDC,0x53,0x28}; // PLACE RECEIVER'S MAC Address here
// Rx_00:   80:7D:3A:DC:66:CC  Board 09
// Rx_00:   80:7D:3A:DC:53:28  Board 13 (Franzis)
 
byte analogInPin=34;

typedef struct struct_message 
{   int id; // must be unique for each sender board
    int x; int y;
} struct_message;
struct_message myData; esp_now_peer_info_t peerInfo;

void OnDataSent(const uint8_t *mac_addr, esp_now_send_status_t status) 
{ Serial.print(status==ESP_NOW_SEND_SUCCESS?"Data Sent ":"Send Fail ");
}
 
void setup() 
{ Serial.begin(115200);  WiFi.mode(WIFI_STA);
  if (esp_now_init() != ESP_OK) { Serial.println("Error initializing ESP-NOW"); return;}
  esp_now_register_send_cb(OnDataSent);
  memcpy(peerInfo.peer_addr, broadcastAddress, 6);
  peerInfo.channel = 0;   peerInfo.encrypt = false;
  if (esp_now_add_peer(&peerInfo) != ESP_OK){ Serial.println("Failed to add peer"); return; }
}
 
void loop() 
{ myData.id=2; myData.x=analogRead(analogInPin);  myData.y=0;
  esp_err_t result = esp_now_send(broadcastAddress, (uint8_t *) &myData, sizeof(myData));
  Serial.println(result==ESP_OK?"Delivery Success":"Delivery Fail");
  delay(1000);
}
